import { ModeEnum } from "@/types";
import { watch } from "vue";
import { findCurrentTaskMarkResult, store } from "../store";

export function keyMouse() {
  function toggleKeyMouse() {
    if (store.setting.uiSetting["normal.mode"] === "keyboard") {
      store.setting.uiSetting["normal.mode"] = "mouse";
    } else {
      store.setting.uiSetting["normal.mode"] = "keyboard";
    }
  }

  // 普通模式更新分数时
  watch(
    () => store.currentQuestion?.score,
    () => {
      if (store.setting.mode === ModeEnum.COMMON) {
        // TODO: findCurrentTaskMarkResult => store.currentMarkResult
        const markResult = findCurrentTaskMarkResult();
        if (markResult && store.currentTask) {
          const scoreList = store.currentTask.questionList.map(
            (q) => q.score || 0
          );
          markResult.scoreList = scoreList as number[];
          markResult.markerScore =
            scoreList.reduce((acc, v) => (acc += v * 100), 0) / 100;
        }
      }
    }
  );

  return { toggleKeyMouse };
}
